module nscodes_stuff

integer, parameter :: max_stat=500
integer               num_stat             !actual number of stations. 
character*2 lstat_code(max_stat)           !Kk, Gc, etc.
character*8 lstat_name(max_stat)           !KOKEE, GILCREEK, etc. 
contains 
! ******************************************************************************
subroutine read_nscodes(lfilin)
use common_variables 
! Read in 2-letter station codes for IVS stations. 
! Should use official ns-codes.txt 
implicit none
character*(*) lfilin
integer, parameter :: lu_tmp=101

open(lu_tmp, file=lfilin)
num_stat=0
do while(.true.) 
  read(lu_tmp,'(a)',end=200) ldum
  if(ldum(1:1) .eq. "*") cycle   !Skip comments
  num_stat=num_stat+1
  read(ldum,*) lstat_code(num_stat),lstat_name(num_stat)
  if(lstat_name(num_stat) .eq. "--------")  num_stat=num_stat-1    !Don't have a station
end do 

200 continue
close(lu_tmp)
return
end subroutine read_nscodes

end module nscodes_stuff  