!************************************************************************
subroutine write_eop_file(leop_sort_tmp,leop_final_file)
use header_stuff
use eop_stuff
use common_variables 
use time_Stuff 
implicit none
character*(*) leop_sort_tmp          !file containing eop data lines in time order. 
character*(*) leop_final_file         !final output file.

! local
integer,parameter :: lu_in=25
integer,parameter :: lu_out=26  
integer i


! Start of code 

open(lu_in,  file=leop_sort_tmp)
open(lu_out, file=leop_final_file)
 
! Handle some possible overrides from control file. 
if(leop_apriori_override .ne. " ") leop_apriori=leop_apriori_override
if(lcrf_apriori_override .ne. " ") lcrf_apriori=lcrf_apriori_override
if(ldescription_override .ne. " ") ldescription=ldescription_override
if(lagency_override .ne. " ")      lagency=lagency_override 

if(ltrf_apriori_override .ne. " ") then
  ltrf_apriori=ltrf_apriori_override
else
  ltrf_apriori="Position= "//trim(lapriori_position)//"   Velocity="//trim(lapriori_velocity)
endif 

if(leop_subdaily_override .ne. " ") then
  leop_subdaily=leop_subdaily_override
else
  ldum=lhf_eop_apriori
  call capitalize(ldum)
  if(index(ldum,"DESAI") .ne. 0) then 
      leop_subdaily="DESAI-SIBOIS"
  else
      leop_subdaily=lhf_eop_apriori
  endif 
endif 

! Note: institution name is truncated to 3 charaters. 
! Write the first 'magic line'
write(lu_out,'("%=IVS-EOP 3.0 IVS ",a19,1x,a3,1x,a19,1x,a19,1x, "TAI R")') lutc_2_iso_time(iutc_prog),lagency, &
&  lutc_2_iso_time(iutc_beg), lutc_2_iso_time(iutc_end)

! Begin header info
write(lu_out,'(a)') "+HEADER"
writE(lu_out,'(A)') "#"
write(lu_out,'(a)') "#      Fle created by "//trim(lversion)
write(lu_out,'(A)') "#      For complete solution information see solve control file "//trim(lcontrol_file) 
write(lu_out,'(A)') "#      EOP values do not include sub-daily variations" 
write(lu_out,'(A)') "#      Solve solution started at "//lsolve_run_time
writE(lu_out,'(A)') "#"
write(lu_out,'(a)') "GENERATION_TIME       "//lutc_2_iso_time(iutc_prog)
write(lu_out,'(a)') "DATA_START            "//lutc_2_iso_time(iutc_beg)
write(lu_out,'(a)') "DATA_END              "//lutc_2_iso_time(iutc_end)
write(lu_out,'(a)') "DESCRIPTION           "//trim(ldescription)
writE(lu_out,'(a)') "ANALYSIS_CENTER       "//trim(lanalysis_center)
write(lu_out,'(a)') "CONTACT               "//trim(lcontact)
write(lu_out,'(a)') "SOFTWARE              Solve  RELEASE="//lsolve_release//" REVISION="//lsolve_revision
write(lu_out,'(a)') "TECHNIQUE             VLBI" 
write(lu_out,'(A)') "NUTATION_TYPE         "//lnutation_type 
write(lu_out,'(A)') "ROTATION_TYPE         UT1-TAI_LOD" 
write(lu_out,'(a)') "EOP_APRIORI           "//trim(leop_apriori)
write(lu_out,'(a)') "CRF_APRIORI           "//trim(lcrf_apriori)
write(lu_out,'(a)') "TRF_APRIORI           "//Trim(ltrf_apriori)
write(lu_out,'(a)') "EOP_SUBDAILY          "//trim(leop_subdaily)

! Now we output the EOP.

writE(lu_out,'(a)') "# "                      
do i=1,10
  if(.not.keop_est(i)) cycle
  write(lu_out,'(A," ",f8.6," ",a)') "EOP_ESTIMATED         "//leop_type(i),eop_constraints(i),leop_units(i)          
end do     
writE(lu_out,'(a)') "# "  
                   
write(lu_out,'(a,i6)') "NUMBER_OF_ENTRIES      ",num_session 
write(lu_out,'(a)') "-HEADER"

! Now we do the EOP stuff 
write(lu_out,'(a)') "+DATA"
call write_eop_unit_lines(lu_out,lnutation_type) 
do i=1,num_session
  read(lu_in,'(a)') line_in
  write(lu_out,'(a)') trim(line_in)
end do 
write(lu_out,'(a)') "-DATA"
write(lu_out,'(a)') "%IVS-EOP 3.0 END" 
close(lu_in,status="delete")
close(lu_out) 

end
